package com.icomsys.dsl;

import com.icomsys.mapper.MessageSendLogMapper;
import com.icomsys.vo.MessageSendLogInfo;
import com.icomsys.vo.MessageSendRequest;
import com.icomsys.vo.MessageSendResponse;
import com.icomsys.vo.SejongMessageSendResponse;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
@RequiredArgsConstructor
public class MessageSendServiceDslImpl implements MessageSendServiceDsl {

    private final MessageSendLogMapper messageSendLogMapper;

    @Override
    public void insertSendLog(SejongMessageSendResponse response, MessageSendRequest request, MessageSendResponse messageSendResponse) {

        String sendYn;
        if (messageSendResponse.getCode().equals("200")) {
            sendYn = "Y";
        }
        else {
            sendYn = "N";
        }
        MessageSendLogInfo messageSendLogInfo = MessageSendLogInfo.builder()
                .sendYn(sendYn)
                .userKey(request.getUserKey())
                .callBack(request.getCallback())
                .receiverTelNo(request.getReceiverTelNo())
                .sendType(messageSendResponse.getSendType())
                .contents(request.getContents())
                .advertisementYn(request.getAdvertisementYn())
                .imageFile1("")
                .imageFile2("")
                .imageFile3("")
                .videoFile("")
                .senderKey(request.getSenderKey())
                .templateCode(request.getTemplateCode())
                .initCallNo(request.getInitCallNo())
                .initCallNo("")
                .apiResponseCode(response.getCode())
                .resultCode(messageSendResponse.getCode())
                .registDate(LocalDateTime.now())
                .optionYn(request.getOptionYn())
                .build();

        messageSendLogMapper.insertSendLog(messageSendLogInfo);
    }

    @Override
    public void updateSendLog(int seq) {
//        messageSendLogMapper.updateSendLog(seq);
    }
}
